SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Object subclass: #Distance
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Distance class methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
newWithAmount: anAmount withUnit: aUnit
	^self new withAmount: anAmount withUnit: aUnit! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 20:08'!
* anInteger
	^Distance newWithAmount: (amount * anInteger)
		withUnit: unit! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 19:55'!
+ anotherDistance
	| selfInAnotherDistanceUnit |
	selfInAnotherDistanceUnit := self convertTo: (anotherDistance factor) .
	^Distance newWithAmount: (selfInAnotherDistanceUnit amount + anotherDistance amount)
		withUnit: (anotherDistance factor)! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 20:06'!
- anotherDistance
	| selfInAnotherDistanceUnit |
	selfInAnotherDistanceUnit := self convertTo: (anotherDistance factor) .
	^Distance newWithAmount: (selfInAnotherDistanceUnit amount - anotherDistance amount)
		withUnit: (anotherDistance factor)! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 20:11'!
/ anInteger
	^Distance newWithAmount: (amount / anInteger)
		withUnit: unit! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:31'!
< anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	^ selfInMeters amount < anotherDistanceInMeters amount! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:32'!
<= anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	^ selfInMeters amount <= anotherDistanceInMeters amount! !

!Distance methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/13/2013 19:03'!
= anotherDistance
	| calculatedDistanceOfSelf calculatedDistanceOfAnotherDistance |
	(anotherDistance isKindOf: Distance) ifFalse: [ ^false ].
	calculatedDistanceOfSelf := self amount * (self factor factor) .
	calculatedDistanceOfAnotherDistance := anotherDistance amount * (anotherDistance factor factor) .
	^ calculatedDistanceOfSelf = calculatedDistanceOfAnotherDistance ! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:31'!
> anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	^ selfInMeters amount > anotherDistanceInMeters amount! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:32'!
>= anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	^ selfInMeters amount >= anotherDistanceInMeters amount! !

!Distance methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/12/2013 18:14'!
amount
	^amount! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:40'!
between: aDistance and: anotherDistance
	| maxDistance minDistance |
	maxDistance := aDistance max: anotherDistance .
	minDistance := aDistance min: anotherDistance .
	^(self < maxDistance) and: [ self > minDistance ]! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/15/2013 19:41'!
by: aDistance
	| selfAmountInMeters aDistanceAmountInMeters |
	selfAmountInMeters := (self convertTo: (Unit newWithFactor: 1)) amount.
	aDistanceAmountInMeters := (aDistance convertTo: (Unit newWithFactor: 1)) amount.
	^Distance newWithAmount: (selfAmountInMeters * aDistanceAmountInMeters) withUnit: self factor ! !

!Distance methodsFor: 'creation' stamp: 'JuanManuelTastzian 5/13/2013 18:17'!
convertTo: aUnit
	| inMeters newAmount |
	inMeters := amount * (unit factor).
	newAmount := inMeters / (aUnit factor).
	^Distance newWithAmount: newAmount withUnit: aUnit! !

!Distance methodsFor: 'creation' stamp: 'JuanManuelTastzian 5/13/2013 17:38'!
factor
	^unit! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 19:43'!
hash 
	^self amount * (self factor factor)! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:34'!
max: anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	(selfInMeters amount < anotherDistanceInMeters amount) ifTrue: [ ^anotherDistance ] .
	^self! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/13/2013 20:35'!
min: anotherDistance 
	| selfInMeters anotherDistanceInMeters |
	selfInMeters := self convertTo: (Unit newWithFactor: 1) .
	anotherDistanceInMeters := anotherDistance convertTo: (Unit newWithFactor: 1) .
	(selfInMeters amount > anotherDistanceInMeters amount) ifTrue: [ ^anotherDistance ] .
	^self! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 20:05'!
negated
	^Distance newWithAmount: (amount negated) withUnit: unit! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/15/2013 21:06'!
printString
    ^(amount printString,  ' ', unit printString asPluralBasedOn: amount).! !

!Distance methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/15/2013 20:25'!
to: aDistance
	^DistanceInterval newWithStart: self andEnd: aDistance by: (Distance newWithAmount: 1 withUnit: (self min: aDistance) factor)! !

!Distance methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/15/2013 20:13'!
to: aDistance by: anotherDistance
	^ DistanceInterval newWithStart: self andEnd: aDistance by: anotherDistance! !

!Distance methodsFor: 'creation' stamp: 'JuanManuelTastzian 5/13/2013 17:31'!
withAmount: aAmount withUnit: aUnit
	amount := aAmount .
	unit := aUnit .! !

Object subclass: #DistanceInterval
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceInterval class methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/13/2013 20:55'!
newWithStart: aDistance andEnd: anotherDistance 
	^DistanceInterval new withStart: aDistance andEnd: anotherDistance! !

!DistanceInterval class methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/15/2013 20:15'!
newWithStart: aDistance andEnd: anotherDistance by: yetAnotherDistance
	^DistanceInterval new withStart: aDistance andEnd: anotherDistance by: yetAnotherDistance! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/15/2013 20:20'!
by
	^by! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/15/2013 20:09'!
by: aDistance 
	^by := aDistance! !

!DistanceInterval methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/20/2013 18:40'!
do: aBlock
	| aValue index size |
	index := 0.
	size := self size.
	[(by amount) * index < size]
		whileTrue: [aValue := from + (by * index).
			index := index + 1.
			aBlock value: aValue]! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/13/2013 20:54'!
from
	^from! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/15/2013 20:34'!
size
	(by amount < 0) ifTrue: [ ^from amount - to amount + 1 ] .
	^to amount - from amount + 1! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/13/2013 20:55'!
to
	^to! !

!DistanceInterval methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/15/2013 20:07'!
withStart: aDistance andEnd: anotherDistance 
	from := aDistance .
	to := anotherDistance .
	by := aDistance min: anotherDistance ! !

!DistanceInterval methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/15/2013 20:16'!
withStart: aDistance andEnd: anotherDistance by: yetAnotherDistance
	from := aDistance .
	to := anotherDistance .
	by := yetAnotherDistance! !

Object subclass: #Unit
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Unit class methodsFor: 'as yet unclassified' stamp: 'JuanManuelTastzian 5/12/2013 22:14'!
newWithFactor: aFactor
	^Unit new withFactor: aFactor! !

!Unit methodsFor: 'distance units' stamp: 'SebaTorres 5/13/2013 01:02'!
= anotherUnit
	^factor = anotherUnit factor.! !

!Unit methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:16'!
factor
	^factor! !

!Unit methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/13/2013 21:09'!
min: aUnit 
	(factor < aUnit factor) ifTrue: [ ^self ] .
	^aUnit! !

!Unit methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:12'!
printString 
	(self factor = (1/1000)) ifTrue: [ ^'millimeter' ] .
	(self factor = (1/100)) ifTrue: [ ^'centimeter' ] .
	(self factor = (1/10)) ifTrue: [ ^'decimeter' ] .
	(self factor = 1) ifTrue: [ ^'meter' ] .
	(self factor = 10) ifTrue: [ ^'decameter' ] .
	(self factor = 100) ifTrue: [ ^'hectometer' ] .
	(self factor = 1000) ifTrue: [ ^'kilometer' ] .! !

!Unit methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:14'!
withFactor: aFactor
	factor := aFactor.! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceTest class methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/12/2013 18:15'!
meter
	^'meter'! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:13'!
centimeter
	^ Unit newWithFactor: 1/100! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
decameter
	^ Unit newWithFactor: 10! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
decimeter
	^ Unit newWithFactor: 1/10! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
hectometer
	^ Unit newWithFactor: 100! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
kilometer
	^ Unit newWithFactor: 1000! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
meter
	^ Unit newWithFactor: 1! !

!DistanceTest methodsFor: 'distance units' stamp: 'JuanManuelTastzian 5/12/2013 22:15'!
millimeter
	^ Unit newWithFactor: 1/1000! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
minusOneMeter 
	^Distance newWithAmount: -1 withUnit: (Unit newWithFactor: 1)! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
oneCentimeter
	^Distance newWithAmount: 1 withUnit: (Unit newWithFactor: 1/100)! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
oneHundredCentimeters
	^Distance newWithAmount: 100 withUnit: (Unit newWithFactor: 1/100)! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
oneMeter
	^Distance newWithAmount: 1 withUnit: (Unit newWithFactor: 1).! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'SebaTorres 5/13/2013 01:30'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter factor = self meter.
	self assert: self twoMeters factor = self meter.
	self assert: self oneHundredCentimeters factor = self centimeter.
	self assert: self twoHundredCentimeters factor = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'JuanManuelTastzian 5/12/2013 17:47'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) factor = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) factor = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) factor = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) factor = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) factor = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) factor = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) factor = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'JuanManuelTastzian 5/13/2013 20:09'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'JuanManuelTastzian 5/13/2013 20:09'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'JuanManuelTastzian 5/13/2013 20:25'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'JuanManuelTastzian 5/13/2013 20:25'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'JuanManuelTastzian 5/13/2013 20:25'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'JuanManuelTastzian 5/13/2013 20:25'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'JuanManuelTastzian 5/20/2013 18:24'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
twoHundredCentimeters
	^Distance newWithAmount: 200 withUnit: (Unit newWithFactor: 1/100)! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
twoMeters
	^Distance newWithAmount: 2 withUnit: (Unit newWithFactor: 1)! !

!DistanceTest methodsFor: 'distance measures' stamp: 'JuanManuelTastzian 5/13/2013 17:42'!
zeroMeters
	^Distance newWithAmount: 0 withUnit: (Unit newWithFactor: 1)! !
